VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form MainForm 
   Caption         =   "WSQ Library Demo"
   ClientHeight    =   5655
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5175
   LinkTopic       =   "Form1"
   ScaleHeight     =   5655
   ScaleWidth      =   5175
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton RegisterButton 
      Caption         =   "Register"
      Height          =   495
      Left            =   3240
      TabIndex        =   3
      Top             =   4200
      Width           =   1335
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   4560
      Top             =   3960
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton SaveButton 
      Caption         =   "Save"
      Enabled         =   0   'False
      Height          =   495
      Left            =   1680
      TabIndex        =   2
      Top             =   4200
      Width           =   1335
   End
   Begin VB.CommandButton OpenButton 
      Caption         =   "Open"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   4200
      Width           =   1335
   End
   Begin VB.PictureBox OutputPicture 
      Align           =   1  'Align Top
      AutoSize        =   -1  'True
      Height          =   3855
      Left            =   0
      ScaleHeight     =   253
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   341
      TabIndex        =   0
      Top             =   0
      Width           =   5175
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Dim CurrentApplicationDrive As String
Dim CurrentApplicationPath As String
Dim DialogCurrentDrive As String
Dim DialogCurrentDirectory As String

Dim lpszDialogFileName As String
Dim fs



'In Visual Basic it is not possible to directly call a C function in a DLL
'if that function uses the _cdecl calling convention. This is because Visual Basic
'uses the _stdcall calling convention for calling functions. This is a problem
'because if _cdecl is used, the calling function is responsible for cleaning up;
'the stack. However, if _stdcall is used, the called function is responsible for
'cleaning up the stack.
'The solution is to use wrapper DLL which wraps __cdecl calls into __stdcall calls.
'Such a wrapper interface is provided in DLL file "WSQ_library_stdcall.dll".


Private Declare Function CreateBMPFromFile Lib "WSQ_library_stdcall.dll" Alias "CreateBMPFromFile_stdcall" (ByVal lpszFileName As String) As Long
Private Declare Function SaveBMPToFile Lib "WSQ_library_stdcall.dll" Alias "SaveBMPToFile_stdcall" (ByVal hBitmap As Long, ByVal lpszFileName As String, ByVal ifiletype As Long) As Long
Private Declare Function RegisterWSQ Lib "WSQ_library_stdcall.dll" Alias "RegisterWSQ_stdcall" () As Long
Private Declare Sub SetShowFilePropertiesDialog Lib "WSQ_library_stdcall.dll" Alias "SetShowFilePropertiesDialog_stdcall" (ByVal file_properties_dialog As Long)
Private Declare Sub ShowFileConverter Lib "WSQ_library_stdcall.dll" Alias "ShowFileConverter_stdcall" ()
Private Declare Function ConvertHBITMAPtoGrayScale256 Lib "WSQ_library_stdcall.dll" Alias "ConvertHBITMAPtoGrayScale256_stdcall" (ByVal hBitmap As Long) As Long
Private Declare Function SaveHBITMAPtoFileAsGrayScale256BMP Lib "WSQ_library_stdcall.dll" Alias "SaveHBITMAPtoFileAsGrayScale256BMP_stdcall" (ByVal hBitmap As Long, ByVal lpszFileName As String) As Long





Private Sub Form_Load()


Left = (Screen.Width - Width) / 2
Top = (Screen.Height - Height) / 2


'Get current application path and drive
Set fs = CreateObject("Scripting.FileSystemObject")
CurrentApplicationDrive = fs.GetDrivename(fs.GetAbsolutePathName(App.Path))
CurrentApplicationPath = fs.GetAbsolutePathName(App.Path)




End Sub

Private Sub OpenButton_Click()

   ' CancelError is True.
   On Error GoTo ErrHandler
   ' Set filters.
CommonDialog1.Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;*.emf;*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;*.rgba;*.rgb;*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp;|FBI Wavelet Scalar Quantization (*.wsq)|*.wsq|Windows bitmaps (*.bmp)|*.bmp|Macintosh TIFF images (*.tiff)|*.tiff|PC TIFF images (*.tif)|*.tif|JPG images (*.jpg)|*.jpg|" & _
"JPEG-2000 Part-1 (*.jp2)|*.jp2|JPEG-2000 Code Stream (*.jpc)|*.jpc|JPE images (*.jpe)|*.jpe|JPEG images (*.jpeg)|*.jpeg|Portable network graphic images (*.png)|*.png|Compuserve Graphic Interchange Format(*.gif)|*gif|Paintshop Pro images (*.psp)|*.psp|JFIF images (*.jfif)|*.jfif|Run length encoded Windows bitmaps (*.rle)|*.rle|Device independant Windows bitmaps (*.dib)|*.dib|Truevision images (*.win)|*.win|Truevision images (*.vst)|*.vst|Truevision images (*.vda)|*.vda|" & _
"Truevision images (*.tga)|*.tga|Truevision images (*.icb)|*.icb|GFI fax images (*.fax)|*.fax|Encapsulated Postscript images (*.eps)|*.eps|ZSoft Paintbrush images (*.pcx)|*.pcx|ZSoft Paintbrush images (*.pcc)|*.pcc|Word 5.x screen capture images (*.scr)|*.scr|Alias/Wavefront images (*.rpf)|*.rpf|Alias/Wavefront images (*.rla)|*.rla|SGI true color images (*.sgi)|*.sgi|SGI true color images with alpha (*.rgba)|*.rgba|SGI true color images (*.rgb)|*.rgb|SGI black/white images (*.bw)|*.bw|" & _
"Photoshop images (*.psd)|*.psd|Photoshop images (*.pdd)|*.pdd|Portable pixel map images (*.ppm)|*.ppm|Portable gray map images (*.pgm)|*.pgm|Portable bitmap images (*.pbm)|*.pbm|Autodesk images (*.cel)|*.cel|Autodesk images (*.pic)|*.pic|Kodak Photo-CD images (*.pcd)|*.pcd|Dr. Halo images (*.cut)|*.cut|Amiga Bitmap Graphic (8 bits)|*.iff|Windows icons (*.ico)|*.ico|Windows metafiles (*.wmf)|*.wmf|Windows enhanced meta files (*.emf)|*.emf"


   ' Specify default filter.
   CommonDialog1.FilterIndex = 1

   ' Display the Open dialog box.
   CommonDialog1.ShowOpen
   ' Call the open file procedure.
   Rem   OpenFile (CommonDialog1.FileName)



   lpszDialogFileName = CommonDialog1.FileName
   CommonDialog1.FileName = ""


   DialogCurrentDrive = fs.GetDrivename(fs.GetAbsolutePathName(CurDir))
   'DialogCurrentDrive = fs.GetDrivename(fs.GetAbsolutePathName(App.Path))
   DialogCurrentDirectory = CurDir


   'ChDir App.Path
   ChDrive CurrentApplicationDrive
   ChDir CurrentApplicationPath


   'Because Visual Basic does not natively support HBITMAP, special function
   'GetPicture is needed to convert HBITMAP (which is returned for WSQ image
   'library DLL) into PictureBox format
   If lpszDialogFileName <> "" Then
   OutputPicture.Picture = GetPicture(CreateBMPFromFile(lpszDialogFileName), vbPicTypeBitmap)
   End If
   On Error GoTo ErrHandler2
 
   SaveButton.Enabled = True
    
    
    
   
   ChDrive DialogCurrentDrive
   ChDir DialogCurrentDirectory
   
   
   Exit Sub

ErrHandler2:
' this error handler for actual file errors
   MsgBox "Error opening file", vbOKOnly, "WSQ Library Demo"
   Exit Sub


ErrHandler:
' User pressed Cancel button.
   Exit Sub




End Sub



Private Sub SaveButton_Click()


Dim iResult As Integer
 

   ' CancelError is True.
   On Error GoTo ErrHandler3
   ' Set filters.
   CommonDialog1.Filter = "WSQ Files (*.wsq)|*.wsq|" & _
   "Windows BMP (*.bmp)|*.bmp|" & _
   "TIFF Files (*.tif)|*.tif|" & _
   "PNG Files (*.png)|*.png|" & _
   "JPEG Files (*.jpg)|*.jpg|" & _
   "Targa Files (*.tga)|*.tga|" & _
   "SGI Files (*.rgb)|*.rgb|" & _
   "JPEG-2000 Part-1 (*.jp2)|*.jp2|" & _
   "JPEG-2000 Code Stream (*.jpc)|*.jpc|" & _
   "PBM - Portable Bitmap Format (*.pbm)|*.pbm|" & _
   "PGM - Portable Graymap Format (*.pgm)|*.pgm|" & _
   "PPM - Portable Pixmap Format (*.ppm)|*.ppm"
   

   ' Specify default filter.
   CommonDialog1.FilterIndex = 1

   CommonDialog1.FileName = ""


   ' Display the Save dialog box.
   CommonDialog1.ShowSave
 
   
   lpszDialogFileName = CommonDialog1.FileName
   CommonDialog1.FileName = ""


   DialogCurrentDrive = fs.GetDrivename(fs.GetAbsolutePathName(CurDir))
   DialogCurrentDirectory = CurDir

   ChDrive CurrentApplicationDrive
   ChDir CurrentApplicationPath
   
   
   If lpszDialogFileName <> "" Then
   SetShowFilePropertiesDialog (1)
   iResult = SaveBMPToFile(OutputPicture.Picture.Handle, lpszDialogFileName, CommonDialog1.FilterIndex)
   End If
   On Error GoTo ErrHandler4



   
   ChDrive DialogCurrentDrive
   ChDir DialogCurrentDirectory

   
   
   
   
   
   Exit Sub

ErrHandler4:
' this error handler for actual file errors
    MsgBox "Error saving file", vbOKOnly, "WSQ Library Demo"
    Exit Sub

ErrHandler3:
' User pressed Cancel button.
    Exit Sub


End Sub

Private Sub RegisterButton_Click()

RegisterWSQ

End Sub



